<?php namespace Site21\ShopaholicProductExtender;

use Backend;
use System\Classes\PluginBase;
use Site21\ShopaholicProductExtender\Classes\Event\Product\ExtendProductFieldsHandler;
use Site21\ShopaholicProductExtender\Classes\Event\Offer\ExtendOfferFieldsHandler;
use Event;

/**
 * ShopaholicProductExtender Plugin Information File
 */
class Plugin extends PluginBase
{
    /**
     * Returns information about this plugin.
     *
     * @return array
     */
    public function pluginDetails()
    {
        return [
            'name'        => 'ShopaholicProductExtender',
            'description' => 'No description provided yet...',
            'author'      => 'Site21',
            'icon'        => 'icon-leaf'
        ];
    }

    /**
     * Register method, called when the plugin is first registered.
     *
     * @return void
     */
    public function register()
    {

    }

    /**
     * Boot method, called right before the request route.
     *
     * @return array
     */
    public function boot()
    {
		Event::subscribe(ExtendProductFieldsHandler::class);
		Event::subscribe(ExtendOfferFieldsHandler::class);
    }

    /**
     * Registers any front-end components implemented in this plugin.
     *
     * @return array
     */
    public function registerComponents()
    {
        return []; // Remove this line to activate

        return [
            'Site21\ShopaholicProductExtender\Components\MyComponent' => 'myComponent',
        ];
    }

    /**
     * Registers any back-end permissions used by this plugin.
     *
     * @return array
     */
    public function registerPermissions()
    {
        return []; // Remove this line to activate

        return [
            'site21.shopaholicproductextender.some_permission' => [
                'tab' => 'ShopaholicProductExtender',
                'label' => 'Some permission'
            ],
        ];
    }

    /**
     * Registers back-end navigation items for this plugin.
     *
     * @return array
     */
    public function registerNavigation()
    {
        return []; // Remove this line to activate

        return [
            'shopaholicproductextender' => [
                'label'       => 'ShopaholicProductExtender',
                'url'         => Backend::url('site21/shopaholicproductextender/mycontroller'),
                'icon'        => 'icon-leaf',
                'permissions' => ['site21.shopaholicproductextender.*'],
                'order'       => 500,
            ],
        ];
    }
}
